/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.api;

import io.micronaut.http.annotation.*;
import io.micronaut.core.annotation.*;
import io.micronaut.http.client.annotation.Client;
import io.micronaut.core.convert.format.Format;
import reactor.core.publisher.Mono;
import example.twitter.model.Error;
import example.twitter.model.MultiSpaceLookupResponse;
import example.twitter.model.Problem;
import java.util.Set;
import example.twitter.model.SingleSpaceLookupResponse;
import javax.annotation.Generated;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.validation.Valid;
import javax.validation.constraints.*;

@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@Client("${openapi-micronaut-client-base-path}")
public interface SpacesApi {
    /**
     * Space lookup by Space ID
     * Returns a variety of information about the Space specified by the requested ID
     *
     * @param id The space id to be retrieved (required)
     * @param spaceFields A comma separated list of Space fields to display. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @return SingleSpaceLookupResponse
     */
    @Get(uri="/2/spaces/{id}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<SingleSpaceLookupResponse> findSpaceById(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[a-zA-Z0-9]{1,13}$") String id, 
        @QueryValue(value="space.fields") @Nullable @Size(min=1) Set<String> spaceFields, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions
    );

    /**
     * Space lookup by their creators
     * Returns a variety of information about the Spaces created by the provided User IDs
     *
     * @param userIds The users to search through (required)
     * @param spaceFields A comma separated list of Space fields to display. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @return MultiSpaceLookupResponse
     */
    @Get(uri="/2/spaces/by/creator_ids")
    @Consumes({"application/json", "application/problem+json"})
    Mono<MultiSpaceLookupResponse> findSpacesByCreatorIds(
        @QueryValue(value="user_ids") @NotNull @Size(min=1) List<String> userIds, 
        @QueryValue(value="space.fields") @Nullable @Size(min=1) Set<String> spaceFields, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions
    );

    /**
     * Space lookup up Space IDs
     * Returns a variety of information about the Spaces specified by the requested IDs
     *
     * @param ids A list of space ids (required)
     * @param spaceFields A comma separated list of Space fields to display. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @return MultiSpaceLookupResponse
     */
    @Get(uri="/2/spaces")
    @Consumes({"application/json", "application/problem+json"})
    Mono<MultiSpaceLookupResponse> findSpacesByIds(
        @QueryValue(value="ids") @NotNull @Size(min=1) List<String> ids, 
        @QueryValue(value="space.fields") @Nullable @Size(min=1) Set<String> spaceFields, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions
    );

    /**
     * Search for Spaces
     * Returns Spaces that match the provided query.
     *
     * @param query The search query (required)
     * @param state The state of spaces to search for (required)
     * @param maxResults The number of results to return. The maximum for this value is 100. (optional)
     * @param spaceFields A comma separated list of Space fields to display. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @return MultiSpaceLookupResponse
     */
    @Get(uri="/2/spaces/search")
    @Consumes({"application/json", "application/problem+json"})
    Mono<MultiSpaceLookupResponse> searchSpaces(
        @QueryValue(value="query") @NotNull String query, 
        @QueryValue(value="state") @NotNull String state, 
        @QueryValue(value="max_results") @Nullable @Min(1) @Max(100) Integer maxResults, 
        @QueryValue(value="space.fields") @Nullable @Size(min=1) Set<String> spaceFields, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions
    );

}
