/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.api;

import io.micronaut.http.annotation.*;
import io.micronaut.core.annotation.*;
import io.micronaut.http.client.annotation.Client;
import io.micronaut.core.convert.format.Format;
import reactor.core.publisher.Mono;
import example.twitter.model.Error;
import example.twitter.model.GenericMultipleUsersLookupResponse;
import example.twitter.model.MultiUserLookupResponse;
import example.twitter.model.Problem;
import java.util.Set;
import example.twitter.model.SingleUserLookupResponse;
import example.twitter.model.UsersBlockingMutationResponse;
import example.twitter.model.UsersFollowingCreateResponse;
import example.twitter.model.UsersFollowingDeleteResponse;
import example.twitter.model.UsersFollowingLookupResponse;
import example.twitter.model.UsersIdBlockRequest;
import example.twitter.model.UsersMutingMutationResponse;
import javax.annotation.Generated;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.validation.Valid;
import javax.validation.constraints.*;

@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@Client("${openapi-micronaut-client-base-path}")
public interface UsersApi {
    /**
     * User lookup by ID
     * This endpoint returns information about a user. Specify user by ID.
     *
     * @param id Required. A User ID. (required)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @return SingleUserLookupResponse
     */
    @Get(uri="/2/users/{id}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<SingleUserLookupResponse> findUserById(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields
    );

    /**
     * User lookup by username
     * This endpoint returns information about a user. Specify user by username.
     *
     * @param username Required. A username. (required)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @return SingleUserLookupResponse
     */
    @Get(uri="/2/users/by/username/{username}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<SingleUserLookupResponse> findUserByUsername(
        @PathVariable(name="username") @NotNull @Pattern(regexp="^[A-Za-z0-9_]{1,15}$") String username, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields
    );

    /**
     * User lookup by IDs
     * This endpoint returns information about users. Specify users by their ID.
     *
     * @param ids Required. A list of User IDs, comma-separated. You can specify up to 100 IDs. (required)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @return MultiUserLookupResponse
     */
    @Get(uri="/2/users")
    @Consumes({"application/json", "application/problem+json"})
    Mono<MultiUserLookupResponse> findUsersById(
        @QueryValue(value="ids") @NotNull @Size(min=1, max=100) List<String> ids, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields
    );

    /**
     * User lookup by usernames
     * This endpoint returns information about users. Specify users by their username.
     *
     * @param usernames Required . A list of usernames, comma-separated. You can specify up to 100 usernames. (required)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @return MultiUserLookupResponse
     */
    @Get(uri="/2/users/by")
    @Consumes({"application/json", "application/problem+json"})
    Mono<MultiUserLookupResponse> findUsersByUsername(
        @QueryValue(value="usernames") @NotNull @Size(min=1, max=100) List<String> usernames, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields
    );

    /**
     * Returns user objects that have liked the provided Tweet ID
     * Returns a list of users that have liked the provided Tweet ID
     *
     * @param id The ID of the Tweet for which to return results (required)
     * @return GenericMultipleUsersLookupResponse
     */
    @Get(uri="/2/tweets/{id}/liking_users")
    @Consumes({"application/json", "application/problem+json"})
    Mono<GenericMultipleUsersLookupResponse> tweetsIdLikingUsers(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id
    );

    /**
     * Returns user objects that have retweeted the provided Tweet ID
     * Returns a list of users that have retweeted the provided Tweet ID
     *
     * @param id The ID of the Tweet for which to return results (required)
     * @return GenericMultipleUsersLookupResponse
     */
    @Get(uri="/2/tweets/{id}/retweeted_by")
    @Consumes({"application/json", "application/problem+json"})
    Mono<GenericMultipleUsersLookupResponse> tweetsIdRetweetingUsers(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id
    );

    /**
     * Block User by User ID
     * Causes the user (in the path) to block the target user. The user (in the path) must match the user context authorizing the request
     *
     * @param id The ID of the user that is requesting to block the target user (required)
     * @param usersIdBlockRequest  (optional)
     * @return UsersBlockingMutationResponse
     */
    @Post(uri="/2/users/{id}/blocking")
    @Consumes({"application/json", "application/problem+json"})
    @Produces({"application/json"})
    Mono<UsersBlockingMutationResponse> usersIdBlock(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @Body @Nullable @Valid UsersIdBlockRequest usersIdBlockRequest
    );

    /**
     * Returns user objects that are blocked by provided user ID
     * Returns a list of users that are blocked by the provided user ID
     *
     * @param id The ID of the user for whom to return results (required)
     * @param maxResults The maximum number of results (optional)
     * @param paginationToken This value is populated by passing the &#39;next_token&#39; or &#39;previous_token&#39; returned in a request to paginate through results. (optional)
     * @return GenericMultipleUsersLookupResponse
     */
    @Get(uri="/2/users/{id}/blocking")
    @Consumes({"application/json", "application/problem+json"})
    Mono<GenericMultipleUsersLookupResponse> usersIdBlocking(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @QueryValue(value="max_results") @Nullable @Min(1) @Max(1000) Integer maxResults, 
        @QueryValue(value="pagination_token") @Nullable @Size(min=16, max=16) String paginationToken
    );

    /**
     * Follow User
     * Causes the user(in the path) to follow, or “request to follow” for protected users, the target user. The user(in the path) must match the user context authorizing the request
     *
     * @param id The ID of the user that is requesting to follow the target user (required)
     * @param usersIdBlockRequest  (optional)
     * @return UsersFollowingCreateResponse
     */
    @Post(uri="/2/users/{id}/following")
    @Consumes({"application/json", "application/problem+json"})
    @Produces({"application/json"})
    Mono<UsersFollowingCreateResponse> usersIdFollow(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @Body @Nullable @Valid UsersIdBlockRequest usersIdBlockRequest
    );

    /**
     * Returns user objects that follow the provided user ID
     * Returns a list of users that follow the provided user ID
     *
     * @param id The ID of the user for whom to return results (required)
     * @param maxResults The maximum number of results (optional)
     * @param paginationToken This value is populated by passing the &#39;next_token&#39; or &#39;previous_token&#39; returned in a request to paginate through results. (optional)
     * @return GenericMultipleUsersLookupResponse
     */
    @Get(uri="/2/users/{id}/followers")
    @Consumes({"application/json", "application/problem+json"})
    Mono<GenericMultipleUsersLookupResponse> usersIdFollowers(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @QueryValue(value="max_results") @Nullable @Min(1) @Max(1000) Integer maxResults, 
        @QueryValue(value="pagination_token") @Nullable @Size(min=16, max=16) String paginationToken
    );

    /**
     * Following by User ID
     * Returns a list of users that are being followed by the provided user ID
     *
     * @param id The ID of the user for whom to return results (required)
     * @param maxResults The maximum number of results (optional)
     * @param paginationToken This value is populated by passing the &#39;next_token&#39; or &#39;previous_token&#39; returned in a request to paginate through results. (optional)
     * @return UsersFollowingLookupResponse
     */
    @Get(uri="/2/users/{id}/following")
    @Consumes({"application/json", "application/problem+json"})
    Mono<UsersFollowingLookupResponse> usersIdFollowing(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @QueryValue(value="max_results") @Nullable @Min(1) @Max(1000) Integer maxResults, 
        @QueryValue(value="pagination_token") @Nullable @Size(min=16, max=16) String paginationToken
    );

    /**
     * Mute User by User ID
     * Causes the user (in the path) to mute the target user. The user (in the path) must match the user context authorizing the request
     *
     * @param id The ID of the user that is requesting to mute the target user (required)
     * @param usersIdBlockRequest  (optional)
     * @return UsersMutingMutationResponse
     */
    @Post(uri="/2/users/{id}/muting")
    @Consumes({"application/json", "application/problem+json"})
    @Produces({"application/json"})
    Mono<UsersMutingMutationResponse> usersIdMute(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @Body @Nullable @Valid UsersIdBlockRequest usersIdBlockRequest
    );

    /**
     * Unblock User by User ID
     * Causes the source user to unblock the target user. The source user must match the user context authorizing the request
     *
     * @param sourceUserId The ID of the user that is requesting to unblock the target user (required)
     * @param targetUserId The ID of the user that the source user is requesting to unblock (required)
     * @return UsersBlockingMutationResponse
     */
    @Delete(uri="/2/users/{source_user_id}/blocking/{target_user_id}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<UsersBlockingMutationResponse> usersIdUnblock(
        @PathVariable(name="source_user_id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String sourceUserId, 
        @PathVariable(name="target_user_id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String targetUserId
    );

    /**
     * Unfollow User
     * Causes the source user to unfollow the target user. The source user must match the user context authorizing the request
     *
     * @param sourceUserId The ID of the user that is requesting to unfollow the target user (required)
     * @param targetUserId The ID of the user that the source user is requesting to unfollow (required)
     * @return UsersFollowingDeleteResponse
     */
    @Delete(uri="/2/users/{source_user_id}/following/{target_user_id}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<UsersFollowingDeleteResponse> usersIdUnfollow(
        @PathVariable(name="source_user_id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String sourceUserId, 
        @PathVariable(name="target_user_id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String targetUserId
    );

    /**
     * Unmute User by User ID
     * Causes the source user to unmute the target user. The source user must match the user context authorizing the request
     *
     * @param sourceUserId The ID of the user that is requesting to unmute the target user (required)
     * @param targetUserId The ID of the user that the source user is requesting to unmute (required)
     * @return UsersMutingMutationResponse
     */
    @Delete(uri="/2/users/{source_user_id}/muting/{target_user_id}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<UsersMutingMutationResponse> usersIdUnmute(
        @PathVariable(name="source_user_id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String sourceUserId, 
        @PathVariable(name="target_user_id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String targetUserId
    );

}
