/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import example.twitter.model.ClientForbiddenProblemAllOf;
import example.twitter.model.ProblemFields;
import java.net.URI;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * A problem that indicates your client is forbidden from making this request.
 */
@JsonPropertyOrder({
  ClientForbiddenProblem.JSON_PROPERTY_DETAIL,
  ClientForbiddenProblem.JSON_PROPERTY_TITLE,
  ClientForbiddenProblem.JSON_PROPERTY_REASON,
  ClientForbiddenProblem.JSON_PROPERTY_REGISTRATION_URL,
  ClientForbiddenProblem.JSON_PROPERTY_TYPE
})
@JsonTypeName("ClientForbiddenProblem")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@Introspected
public class ClientForbiddenProblem {
    public static final String JSON_PROPERTY_DETAIL = "detail";
    private String detail;

    public static final String JSON_PROPERTY_TITLE = "title";
    private String title;

    /**
     * Gets or Sets reason
     */
    public enum ReasonEnum {
        OFFICIAL_CLIENT_FORBIDDEN("official-client-forbidden"),
        CLIENT_NOT_ENROLLED("client-not-enrolled");

        private String value;

        ReasonEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static ReasonEnum fromValue(String value) {
            for (ReasonEnum b : ReasonEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_REASON = "reason";
    private ReasonEnum reason;

    public static final String JSON_PROPERTY_REGISTRATION_URL = "registration_url";
    private URI registrationUrl;

    /**
     * Gets or Sets type
     */
    public enum TypeEnum {
        HTTPS_API_TWITTER_COM_2_PROBLEMS_CLIENT_FORBIDDEN("https://api.twitter.com/2/problems/client-forbidden");

        private String value;

        TypeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static TypeEnum fromValue(String value) {
            for (TypeEnum b : TypeEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_TYPE = "type";
    private TypeEnum type;

    public ClientForbiddenProblem(String detail, String title) {
        this.detail = detail;
        this.title = title;
    }

    public ClientForbiddenProblem detail(String detail) {
        this.detail = detail;
        return this;
    }

    /**
     * Get detail
     * @return detail
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_DETAIL)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getDetail() {
        return detail;
    }

    @JsonProperty(JSON_PROPERTY_DETAIL)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setDetail(String detail) {
        this.detail = detail;
    }

    public ClientForbiddenProblem title(String title) {
        this.title = title;
        return this;
    }

    /**
     * Get title
     * @return title
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_TITLE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getTitle() {
        return title;
    }

    @JsonProperty(JSON_PROPERTY_TITLE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setTitle(String title) {
        this.title = title;
    }

    public ClientForbiddenProblem reason(ReasonEnum reason) {
        this.reason = reason;
        return this;
    }

    /**
     * Get reason
     * @return reason
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_REASON)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public ReasonEnum getReason() {
        return reason;
    }

    @JsonProperty(JSON_PROPERTY_REASON)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setReason(ReasonEnum reason) {
        this.reason = reason;
    }

    public ClientForbiddenProblem registrationUrl(URI registrationUrl) {
        this.registrationUrl = registrationUrl;
        return this;
    }

    /**
     * Get registrationUrl
     * @return registrationUrl
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_REGISTRATION_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getRegistrationUrl() {
        return registrationUrl;
    }

    @JsonProperty(JSON_PROPERTY_REGISTRATION_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setRegistrationUrl(URI registrationUrl) {
        this.registrationUrl = registrationUrl;
    }

    public ClientForbiddenProblem type(TypeEnum type) {
        this.type = type;
        return this;
    }

    /**
     * Get type
     * @return type
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public TypeEnum getType() {
        return type;
    }

    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setType(TypeEnum type) {
        this.type = type;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ClientForbiddenProblem clientForbiddenProblem = (ClientForbiddenProblem) o;
        return Objects.equals(this.detail, clientForbiddenProblem.detail) &&
            Objects.equals(this.title, clientForbiddenProblem.title) &&
            Objects.equals(this.reason, clientForbiddenProblem.reason) &&
            Objects.equals(this.registrationUrl, clientForbiddenProblem.registrationUrl) &&
            Objects.equals(this.type, clientForbiddenProblem.type);
    }

    @Override
    public int hashCode() {
        return Objects.hash(detail, title, reason, registrationUrl, type);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ClientForbiddenProblem {\n");
        sb.append("    detail: ").append(toIndentedString(detail)).append("\n");
        sb.append("    title: ").append(toIndentedString(title)).append("\n");
        sb.append("    reason: ").append(toIndentedString(reason)).append("\n");
        sb.append("    registrationUrl: ").append(toIndentedString(registrationUrl)).append("\n");
        sb.append("    type: ").append(toIndentedString(type)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
