/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import example.twitter.model.Expansions;
import example.twitter.model.FilteredStreamingTweetOneOf;
import example.twitter.model.FilteredStreamingTweetOneOf1;
import example.twitter.model.FilteredStreamingTweetOneOfMatchingRules;
import example.twitter.model.Problem;
import example.twitter.model.Tweet;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * A tweet or error that can be returned by the streaming tweet API
 */
@JsonPropertyOrder({
  FilteredStreamingTweet.JSON_PROPERTY_DATA,
  FilteredStreamingTweet.JSON_PROPERTY_INCLUDES,
  FilteredStreamingTweet.JSON_PROPERTY_MATCHING_RULES,
  FilteredStreamingTweet.JSON_PROPERTY_ERRORS
})
@JsonTypeName("FilteredStreamingTweet")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@Introspected
public class FilteredStreamingTweet {
    public static final String JSON_PROPERTY_DATA = "data";
    private Tweet data;

    public static final String JSON_PROPERTY_INCLUDES = "includes";
    private Expansions includes;

    public static final String JSON_PROPERTY_MATCHING_RULES = "matching_rules";
    private List<FilteredStreamingTweetOneOfMatchingRules> matchingRules = new ArrayList<>();

    public static final String JSON_PROPERTY_ERRORS = "errors";
    private List<Problem> errors = new ArrayList<>();

    public FilteredStreamingTweet(Tweet data, List<FilteredStreamingTweetOneOfMatchingRules> matchingRules, List<Problem> errors) {
        this.data = data;
        this.matchingRules = matchingRules;
        this.errors = errors;
    }

    public FilteredStreamingTweet data(Tweet data) {
        this.data = data;
        return this;
    }

    /**
     * Get data
     * @return data
     **/
    @Valid
    @NotNull
    @JsonProperty(JSON_PROPERTY_DATA)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public Tweet getData() {
        return data;
    }

    @JsonProperty(JSON_PROPERTY_DATA)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setData(Tweet data) {
        this.data = data;
    }

    public FilteredStreamingTweet includes(Expansions includes) {
        this.includes = includes;
        return this;
    }

    /**
     * Get includes
     * @return includes
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_INCLUDES)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Expansions getIncludes() {
        return includes;
    }

    @JsonProperty(JSON_PROPERTY_INCLUDES)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setIncludes(Expansions includes) {
        this.includes = includes;
    }

    public FilteredStreamingTweet matchingRules(List<FilteredStreamingTweetOneOfMatchingRules> matchingRules) {
        this.matchingRules = matchingRules;
        return this;
    }

    public FilteredStreamingTweet addMatchingRulesItem(FilteredStreamingTweetOneOfMatchingRules matchingRulesItem) {
        this.matchingRules.add(matchingRulesItem);
        return this;
    }

    /**
     * The list of rules which matched the tweet
     * @return matchingRules
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_MATCHING_RULES)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public List<FilteredStreamingTweetOneOfMatchingRules> getMatchingRules() {
        return matchingRules;
    }

    @JsonProperty(JSON_PROPERTY_MATCHING_RULES)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setMatchingRules(List<FilteredStreamingTweetOneOfMatchingRules> matchingRules) {
        this.matchingRules = matchingRules;
    }

    public FilteredStreamingTweet errors(List<Problem> errors) {
        this.errors = errors;
        return this;
    }

    public FilteredStreamingTweet addErrorsItem(Problem errorsItem) {
        this.errors.add(errorsItem);
        return this;
    }

    /**
     * Get errors
     * @return errors
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_ERRORS)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public List<Problem> getErrors() {
        return errors;
    }

    @JsonProperty(JSON_PROPERTY_ERRORS)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setErrors(List<Problem> errors) {
        this.errors = errors;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        FilteredStreamingTweet filteredStreamingTweet = (FilteredStreamingTweet) o;
        return Objects.equals(this.data, filteredStreamingTweet.data) &&
            Objects.equals(this.includes, filteredStreamingTweet.includes) &&
            Objects.equals(this.matchingRules, filteredStreamingTweet.matchingRules) &&
            Objects.equals(this.errors, filteredStreamingTweet.errors);
    }

    @Override
    public int hashCode() {
        return Objects.hash(data, includes, matchingRules, errors);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class FilteredStreamingTweet {\n");
        sb.append("    data: ").append(toIndentedString(data)).append("\n");
        sb.append("    includes: ").append(toIndentedString(includes)).append("\n");
        sb.append("    matchingRules: ").append(toIndentedString(matchingRules)).append("\n");
        sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
