/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonTypeName;
import example.twitter.model.Expansions;
import example.twitter.model.FilteredStreamingTweetOneOfMatchingRules;
import example.twitter.model.Tweet;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * The values returned with a successful streamed tweet. Includes the user provided rules that the tweet matched.
 */
@JsonPropertyOrder({
  FilteredStreamingTweetOneOf.JSON_PROPERTY_DATA,
  FilteredStreamingTweetOneOf.JSON_PROPERTY_INCLUDES,
  FilteredStreamingTweetOneOf.JSON_PROPERTY_MATCHING_RULES
})
@JsonTypeName("FilteredStreamingTweet_oneOf")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@Introspected
public class FilteredStreamingTweetOneOf {
    public static final String JSON_PROPERTY_DATA = "data";
    private Tweet data;

    public static final String JSON_PROPERTY_INCLUDES = "includes";
    private Expansions includes;

    public static final String JSON_PROPERTY_MATCHING_RULES = "matching_rules";
    private List<FilteredStreamingTweetOneOfMatchingRules> matchingRules = new ArrayList<>();

    public FilteredStreamingTweetOneOf(Tweet data, List<FilteredStreamingTweetOneOfMatchingRules> matchingRules) {
        this.data = data;
        this.matchingRules = matchingRules;
    }

    public FilteredStreamingTweetOneOf data(Tweet data) {
        this.data = data;
        return this;
    }

    /**
     * Get data
     * @return data
     **/
    @Valid
    @NotNull
    @JsonProperty(JSON_PROPERTY_DATA)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public Tweet getData() {
        return data;
    }

    @JsonProperty(JSON_PROPERTY_DATA)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setData(Tweet data) {
        this.data = data;
    }

    public FilteredStreamingTweetOneOf includes(Expansions includes) {
        this.includes = includes;
        return this;
    }

    /**
     * Get includes
     * @return includes
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_INCLUDES)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Expansions getIncludes() {
        return includes;
    }

    @JsonProperty(JSON_PROPERTY_INCLUDES)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setIncludes(Expansions includes) {
        this.includes = includes;
    }

    public FilteredStreamingTweetOneOf matchingRules(List<FilteredStreamingTweetOneOfMatchingRules> matchingRules) {
        this.matchingRules = matchingRules;
        return this;
    }

    public FilteredStreamingTweetOneOf addMatchingRulesItem(FilteredStreamingTweetOneOfMatchingRules matchingRulesItem) {
        this.matchingRules.add(matchingRulesItem);
        return this;
    }

    /**
     * The list of rules which matched the tweet
     * @return matchingRules
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_MATCHING_RULES)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public List<FilteredStreamingTweetOneOfMatchingRules> getMatchingRules() {
        return matchingRules;
    }

    @JsonProperty(JSON_PROPERTY_MATCHING_RULES)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setMatchingRules(List<FilteredStreamingTweetOneOfMatchingRules> matchingRules) {
        this.matchingRules = matchingRules;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        FilteredStreamingTweetOneOf filteredStreamingTweetOneOf = (FilteredStreamingTweetOneOf) o;
        return Objects.equals(this.data, filteredStreamingTweetOneOf.data) &&
            Objects.equals(this.includes, filteredStreamingTweetOneOf.includes) &&
            Objects.equals(this.matchingRules, filteredStreamingTweetOneOf.matchingRules);
    }

    @Override
    public int hashCode() {
        return Objects.hash(data, includes, matchingRules);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class FilteredStreamingTweetOneOf {\n");
        sb.append("    data: ").append(toIndentedString(data)).append("\n");
        sb.append("    includes: ").append(toIndentedString(includes)).append("\n");
        sb.append("    matchingRules: ").append(toIndentedString(matchingRules)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
