/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import example.twitter.model.AnimatedGif;
import example.twitter.model.Photo;
import example.twitter.model.Video;
import example.twitter.model.VideoAllOfNonPublicMetrics;
import example.twitter.model.VideoAllOfOrganicMetrics;
import example.twitter.model.VideoAllOfPromotedMetrics;
import example.twitter.model.VideoAllOfPublicMetrics;
import java.net.URI;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * Media
 */
@JsonPropertyOrder({
  Media.JSON_PROPERTY_TYPE,
  Media.JSON_PROPERTY_HEIGHT,
  Media.JSON_PROPERTY_MEDIA_KEY,
  Media.JSON_PROPERTY_WIDTH,
  Media.JSON_PROPERTY_ALT_TEXT,
  Media.JSON_PROPERTY_URL,
  Media.JSON_PROPERTY_DURATION_MS,
  Media.JSON_PROPERTY_NON_PUBLIC_METRICS,
  Media.JSON_PROPERTY_ORGANIC_METRICS,
  Media.JSON_PROPERTY_PREVIEW_IMAGE_URL,
  Media.JSON_PROPERTY_PROMOTED_METRICS,
  Media.JSON_PROPERTY_PUBLIC_METRICS
})
@JsonTypeName("Media")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@JsonIgnoreProperties(
  value = "type", // ignore manually set type, it will be automatically generated by Jackson during serialization
  allowSetters = true // allows the type to be set during deserialization
)
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "type", visible = true)
@JsonSubTypes({
  @JsonSubTypes.Type(value = AnimatedGif.class, name = "animated_gif"),
  @JsonSubTypes.Type(value = Photo.class, name = "photo"),
  @JsonSubTypes.Type(value = Video.class, name = "video"),
})

@Introspected
public class Media {
    public static final String JSON_PROPERTY_TYPE = "type";
    protected String type;

    public static final String JSON_PROPERTY_HEIGHT = "height";
    private Integer height;

    public static final String JSON_PROPERTY_MEDIA_KEY = "media_key";
    private String mediaKey;

    public static final String JSON_PROPERTY_WIDTH = "width";
    private Integer width;

    public static final String JSON_PROPERTY_ALT_TEXT = "alt_text";
    private String altText;

    public static final String JSON_PROPERTY_URL = "url";
    private URI url;

    public static final String JSON_PROPERTY_DURATION_MS = "duration_ms";
    private Integer durationMs;

    public static final String JSON_PROPERTY_NON_PUBLIC_METRICS = "non_public_metrics";
    private VideoAllOfNonPublicMetrics nonPublicMetrics;

    public static final String JSON_PROPERTY_ORGANIC_METRICS = "organic_metrics";
    private VideoAllOfOrganicMetrics organicMetrics;

    public static final String JSON_PROPERTY_PREVIEW_IMAGE_URL = "preview_image_url";
    private URI previewImageUrl;

    public static final String JSON_PROPERTY_PROMOTED_METRICS = "promoted_metrics";
    private VideoAllOfPromotedMetrics promotedMetrics;

    public static final String JSON_PROPERTY_PUBLIC_METRICS = "public_metrics";
    private VideoAllOfPublicMetrics publicMetrics;

    public Media(String type) {
        this.type = type;
    }

    public Media type(String type) {
        this.type = type;
        return this;
    }

    /**
     * Get type
     * @return type
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getType() {
        return type;
    }

    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setType(String type) {
        this.type = type;
    }

    public Media height(Integer height) {
        this.height = height;
        return this;
    }

    /**
     * The height of the media in pixels
     * minimum: 0
     * @return height
     **/
    @Nullable
    @Min(0)
    @JsonProperty(JSON_PROPERTY_HEIGHT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getHeight() {
        return height;
    }

    @JsonProperty(JSON_PROPERTY_HEIGHT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setHeight(Integer height) {
        this.height = height;
    }

    public Media mediaKey(String mediaKey) {
        this.mediaKey = mediaKey;
        return this;
    }

    /**
     * The Media Key identifier for this attachment.
     * @return mediaKey
     **/
    @Nullable
    @Pattern(regexp="^([0-9]+)_([0-9]+)$")
    @JsonProperty(JSON_PROPERTY_MEDIA_KEY)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getMediaKey() {
        return mediaKey;
    }

    @JsonProperty(JSON_PROPERTY_MEDIA_KEY)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setMediaKey(String mediaKey) {
        this.mediaKey = mediaKey;
    }

    public Media width(Integer width) {
        this.width = width;
        return this;
    }

    /**
     * The width of the media in pixels
     * minimum: 0
     * @return width
     **/
    @Nullable
    @Min(0)
    @JsonProperty(JSON_PROPERTY_WIDTH)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getWidth() {
        return width;
    }

    @JsonProperty(JSON_PROPERTY_WIDTH)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setWidth(Integer width) {
        this.width = width;
    }

    public Media altText(String altText) {
        this.altText = altText;
        return this;
    }

    /**
     * Get altText
     * @return altText
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_ALT_TEXT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getAltText() {
        return altText;
    }

    @JsonProperty(JSON_PROPERTY_ALT_TEXT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setAltText(String altText) {
        this.altText = altText;
    }

    public Media url(URI url) {
        this.url = url;
        return this;
    }

    /**
     * Get url
     * @return url
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getUrl() {
        return url;
    }

    @JsonProperty(JSON_PROPERTY_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setUrl(URI url) {
        this.url = url;
    }

    public Media durationMs(Integer durationMs) {
        this.durationMs = durationMs;
        return this;
    }

    /**
     * Get durationMs
     * @return durationMs
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_DURATION_MS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getDurationMs() {
        return durationMs;
    }

    @JsonProperty(JSON_PROPERTY_DURATION_MS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setDurationMs(Integer durationMs) {
        this.durationMs = durationMs;
    }

    public Media nonPublicMetrics(VideoAllOfNonPublicMetrics nonPublicMetrics) {
        this.nonPublicMetrics = nonPublicMetrics;
        return this;
    }

    /**
     * Get nonPublicMetrics
     * @return nonPublicMetrics
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_NON_PUBLIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public VideoAllOfNonPublicMetrics getNonPublicMetrics() {
        return nonPublicMetrics;
    }

    @JsonProperty(JSON_PROPERTY_NON_PUBLIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setNonPublicMetrics(VideoAllOfNonPublicMetrics nonPublicMetrics) {
        this.nonPublicMetrics = nonPublicMetrics;
    }

    public Media organicMetrics(VideoAllOfOrganicMetrics organicMetrics) {
        this.organicMetrics = organicMetrics;
        return this;
    }

    /**
     * Get organicMetrics
     * @return organicMetrics
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_ORGANIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public VideoAllOfOrganicMetrics getOrganicMetrics() {
        return organicMetrics;
    }

    @JsonProperty(JSON_PROPERTY_ORGANIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setOrganicMetrics(VideoAllOfOrganicMetrics organicMetrics) {
        this.organicMetrics = organicMetrics;
    }

    public Media previewImageUrl(URI previewImageUrl) {
        this.previewImageUrl = previewImageUrl;
        return this;
    }

    /**
     * Get previewImageUrl
     * @return previewImageUrl
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_PREVIEW_IMAGE_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getPreviewImageUrl() {
        return previewImageUrl;
    }

    @JsonProperty(JSON_PROPERTY_PREVIEW_IMAGE_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setPreviewImageUrl(URI previewImageUrl) {
        this.previewImageUrl = previewImageUrl;
    }

    public Media promotedMetrics(VideoAllOfPromotedMetrics promotedMetrics) {
        this.promotedMetrics = promotedMetrics;
        return this;
    }

    /**
     * Get promotedMetrics
     * @return promotedMetrics
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_PROMOTED_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public VideoAllOfPromotedMetrics getPromotedMetrics() {
        return promotedMetrics;
    }

    @JsonProperty(JSON_PROPERTY_PROMOTED_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setPromotedMetrics(VideoAllOfPromotedMetrics promotedMetrics) {
        this.promotedMetrics = promotedMetrics;
    }

    public Media publicMetrics(VideoAllOfPublicMetrics publicMetrics) {
        this.publicMetrics = publicMetrics;
        return this;
    }

    /**
     * Get publicMetrics
     * @return publicMetrics
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_PUBLIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public VideoAllOfPublicMetrics getPublicMetrics() {
        return publicMetrics;
    }

    @JsonProperty(JSON_PROPERTY_PUBLIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setPublicMetrics(VideoAllOfPublicMetrics publicMetrics) {
        this.publicMetrics = publicMetrics;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Media media = (Media) o;
        return Objects.equals(this.type, media.type) &&
            Objects.equals(this.height, media.height) &&
            Objects.equals(this.mediaKey, media.mediaKey) &&
            Objects.equals(this.width, media.width) &&
            Objects.equals(this.altText, media.altText) &&
            Objects.equals(this.url, media.url) &&
            Objects.equals(this.durationMs, media.durationMs) &&
            Objects.equals(this.nonPublicMetrics, media.nonPublicMetrics) &&
            Objects.equals(this.organicMetrics, media.organicMetrics) &&
            Objects.equals(this.previewImageUrl, media.previewImageUrl) &&
            Objects.equals(this.promotedMetrics, media.promotedMetrics) &&
            Objects.equals(this.publicMetrics, media.publicMetrics);
    }

    @Override
    public int hashCode() {
        return Objects.hash(type, height, mediaKey, width, altText, url, durationMs, nonPublicMetrics, organicMetrics, previewImageUrl, promotedMetrics, publicMetrics);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Media {\n");
        sb.append("    type: ").append(toIndentedString(type)).append("\n");
        sb.append("    height: ").append(toIndentedString(height)).append("\n");
        sb.append("    mediaKey: ").append(toIndentedString(mediaKey)).append("\n");
        sb.append("    width: ").append(toIndentedString(width)).append("\n");
        sb.append("    altText: ").append(toIndentedString(altText)).append("\n");
        sb.append("    url: ").append(toIndentedString(url)).append("\n");
        sb.append("    durationMs: ").append(toIndentedString(durationMs)).append("\n");
        sb.append("    nonPublicMetrics: ").append(toIndentedString(nonPublicMetrics)).append("\n");
        sb.append("    organicMetrics: ").append(toIndentedString(organicMetrics)).append("\n");
        sb.append("    previewImageUrl: ").append(toIndentedString(previewImageUrl)).append("\n");
        sb.append("    promotedMetrics: ").append(toIndentedString(promotedMetrics)).append("\n");
        sb.append("    publicMetrics: ").append(toIndentedString(publicMetrics)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
