/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import example.twitter.model.CommonMediaFields;
import example.twitter.model.PhotoAllOf;
import java.net.URI;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * Photo
 */
@JsonPropertyOrder({
  Photo.JSON_PROPERTY_HEIGHT,
  Photo.JSON_PROPERTY_MEDIA_KEY,
  Photo.JSON_PROPERTY_WIDTH,
  Photo.JSON_PROPERTY_ALT_TEXT,
  Photo.JSON_PROPERTY_TYPE,
  Photo.JSON_PROPERTY_URL
})
@JsonTypeName("Photo")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@Introspected
public class Photo {
    public static final String JSON_PROPERTY_HEIGHT = "height";
    private Integer height;

    public static final String JSON_PROPERTY_MEDIA_KEY = "media_key";
    private String mediaKey;

    public static final String JSON_PROPERTY_WIDTH = "width";
    private Integer width;

    public static final String JSON_PROPERTY_ALT_TEXT = "alt_text";
    private String altText;

    /**
     * Gets or Sets type
     */
    public enum TypeEnum {
        PHOTO("photo");

        private String value;

        TypeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static TypeEnum fromValue(String value) {
            for (TypeEnum b : TypeEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_TYPE = "type";
    private TypeEnum type;

    public static final String JSON_PROPERTY_URL = "url";
    private URI url;

    public Photo() {
    }

    public Photo height(Integer height) {
        this.height = height;
        return this;
    }

    /**
     * The height of the media in pixels
     * minimum: 0
     * @return height
     **/
    @Nullable
    @Min(0)
    @JsonProperty(JSON_PROPERTY_HEIGHT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getHeight() {
        return height;
    }

    @JsonProperty(JSON_PROPERTY_HEIGHT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setHeight(Integer height) {
        this.height = height;
    }

    public Photo mediaKey(String mediaKey) {
        this.mediaKey = mediaKey;
        return this;
    }

    /**
     * The Media Key identifier for this attachment.
     * @return mediaKey
     **/
    @Nullable
    @Pattern(regexp="^([0-9]+)_([0-9]+)$")
    @JsonProperty(JSON_PROPERTY_MEDIA_KEY)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getMediaKey() {
        return mediaKey;
    }

    @JsonProperty(JSON_PROPERTY_MEDIA_KEY)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setMediaKey(String mediaKey) {
        this.mediaKey = mediaKey;
    }

    public Photo width(Integer width) {
        this.width = width;
        return this;
    }

    /**
     * The width of the media in pixels
     * minimum: 0
     * @return width
     **/
    @Nullable
    @Min(0)
    @JsonProperty(JSON_PROPERTY_WIDTH)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getWidth() {
        return width;
    }

    @JsonProperty(JSON_PROPERTY_WIDTH)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setWidth(Integer width) {
        this.width = width;
    }

    public Photo altText(String altText) {
        this.altText = altText;
        return this;
    }

    /**
     * Get altText
     * @return altText
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_ALT_TEXT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getAltText() {
        return altText;
    }

    @JsonProperty(JSON_PROPERTY_ALT_TEXT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setAltText(String altText) {
        this.altText = altText;
    }

    public Photo type(TypeEnum type) {
        this.type = type;
        return this;
    }

    /**
     * Get type
     * @return type
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public TypeEnum getType() {
        return type;
    }

    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setType(TypeEnum type) {
        this.type = type;
    }

    public Photo url(URI url) {
        this.url = url;
        return this;
    }

    /**
     * Get url
     * @return url
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getUrl() {
        return url;
    }

    @JsonProperty(JSON_PROPERTY_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setUrl(URI url) {
        this.url = url;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Photo photo = (Photo) o;
        return Objects.equals(this.height, photo.height) &&
            Objects.equals(this.mediaKey, photo.mediaKey) &&
            Objects.equals(this.width, photo.width) &&
            Objects.equals(this.altText, photo.altText) &&
            Objects.equals(this.type, photo.type) &&
            Objects.equals(this.url, photo.url);
    }

    @Override
    public int hashCode() {
        return Objects.hash(height, mediaKey, width, altText, type, url);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Photo {\n");
        sb.append("    height: ").append(toIndentedString(height)).append("\n");
        sb.append("    mediaKey: ").append(toIndentedString(mediaKey)).append("\n");
        sb.append("    width: ").append(toIndentedString(width)).append("\n");
        sb.append("    altText: ").append(toIndentedString(altText)).append("\n");
        sb.append("    type: ").append(toIndentedString(type)).append("\n");
        sb.append("    url: ").append(toIndentedString(url)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
