/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import example.twitter.model.ClientDisconnectedProblem;
import example.twitter.model.ClientForbiddenProblem;
import example.twitter.model.ConflictProblem;
import example.twitter.model.ConnectionExceptionProblem;
import example.twitter.model.DisallowedResourceProblem;
import example.twitter.model.DuplicateRuleProblem;
import example.twitter.model.FieldUnauthorizedProblem;
import example.twitter.model.GenericProblem;
import example.twitter.model.InvalidRequestProblem;
import example.twitter.model.InvalidRequestProblemAllOfErrors;
import example.twitter.model.InvalidRuleProblem;
import example.twitter.model.OperationalDisconnectProblem;
import example.twitter.model.ResourceNotFoundProblem;
import example.twitter.model.ResourceUnauthorizedProblem;
import example.twitter.model.ResourceUnavailableProblem;
import example.twitter.model.RulesCapProblem;
import example.twitter.model.UnsupportedAuthenticationProblem;
import example.twitter.model.UsageCapExceededProblem;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * An HTTP Problem Details object, as defined in IETF RFC 7807 (https://tools.ietf.org/html/rfc7807).
 */
@JsonPropertyOrder({
  Problem.JSON_PROPERTY_TYPE,
  Problem.JSON_PROPERTY_DETAIL,
  Problem.JSON_PROPERTY_TITLE,
  Problem.JSON_PROPERTY_STATUS,
  Problem.JSON_PROPERTY_ERRORS,
  Problem.JSON_PROPERTY_REASON,
  Problem.JSON_PROPERTY_REGISTRATION_URL,
  Problem.JSON_PROPERTY_PARAMETER,
  Problem.JSON_PROPERTY_RESOURCE_ID,
  Problem.JSON_PROPERTY_RESOURCE_TYPE,
  Problem.JSON_PROPERTY_VALUE,
  Problem.JSON_PROPERTY_SECTION,
  Problem.JSON_PROPERTY_FIELD,
  Problem.JSON_PROPERTY_PERIOD,
  Problem.JSON_PROPERTY_SCOPE,
  Problem.JSON_PROPERTY_CONNECTION_ISSUE,
  Problem.JSON_PROPERTY_DISCONNECT_TYPE
})
@JsonTypeName("Problem")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@JsonIgnoreProperties(
  value = "type", // ignore manually set type, it will be automatically generated by Jackson during serialization
  allowSetters = true // allows the type to be set during deserialization
)
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "type", visible = true)
@JsonSubTypes({
  @JsonSubTypes.Type(value = GenericProblem.class, name = "about:blank"),
  @JsonSubTypes.Type(value = ClientDisconnectedProblem.class, name = "https://api.twitter.com/2/problems/client-disconnected"),
  @JsonSubTypes.Type(value = ClientForbiddenProblem.class, name = "https://api.twitter.com/2/problems/client-forbidden"),
  @JsonSubTypes.Type(value = ConflictProblem.class, name = "https://api.twitter.com/2/problems/conflict"),
  @JsonSubTypes.Type(value = DisallowedResourceProblem.class, name = "https://api.twitter.com/2/problems/disallowed-resource"),
  @JsonSubTypes.Type(value = DuplicateRuleProblem.class, name = "https://api.twitter.com/2/problems/duplicate-rules"),
  @JsonSubTypes.Type(value = InvalidRequestProblem.class, name = "https://api.twitter.com/2/problems/invalid-request"),
  @JsonSubTypes.Type(value = InvalidRuleProblem.class, name = "https://api.twitter.com/2/problems/invalid-rules"),
  @JsonSubTypes.Type(value = FieldUnauthorizedProblem.class, name = "https://api.twitter.com/2/problems/not-authorized-for-field"),
  @JsonSubTypes.Type(value = ResourceUnauthorizedProblem.class, name = "https://api.twitter.com/2/problems/not-authorized-for-resource"),
  @JsonSubTypes.Type(value = OperationalDisconnectProblem.class, name = "https://api.twitter.com/2/problems/operational-disconnect"),
  @JsonSubTypes.Type(value = ResourceNotFoundProblem.class, name = "https://api.twitter.com/2/problems/resource-not-found"),
  @JsonSubTypes.Type(value = ResourceUnavailableProblem.class, name = "https://api.twitter.com/2/problems/resource-unavailable"),
  @JsonSubTypes.Type(value = RulesCapProblem.class, name = "https://api.twitter.com/2/problems/rule-cap"),
  @JsonSubTypes.Type(value = ConnectionExceptionProblem.class, name = "https://api.twitter.com/2/problems/streaming-connection"),
  @JsonSubTypes.Type(value = UnsupportedAuthenticationProblem.class, name = "https://api.twitter.com/2/problems/unsupported-authentication"),
  @JsonSubTypes.Type(value = UsageCapExceededProblem.class, name = "https://api.twitter.com/2/problems/usage-capped"),
})

@Introspected
public class Problem {
    public static final String JSON_PROPERTY_TYPE = "type";
    protected String type;

    public static final String JSON_PROPERTY_DETAIL = "detail";
    private String detail;

    public static final String JSON_PROPERTY_TITLE = "title";
    private String title;

    public static final String JSON_PROPERTY_STATUS = "status";
    private Integer status;

    public static final String JSON_PROPERTY_ERRORS = "errors";
    private List<InvalidRequestProblemAllOfErrors> errors = null;

    /**
     * Gets or Sets reason
     */
    public enum ReasonEnum {
        OFFICIAL_CLIENT_FORBIDDEN("official-client-forbidden"),
        CLIENT_NOT_ENROLLED("client-not-enrolled");

        private String value;

        ReasonEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static ReasonEnum fromValue(String value) {
            for (ReasonEnum b : ReasonEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_REASON = "reason";
    private ReasonEnum reason;

    public static final String JSON_PROPERTY_REGISTRATION_URL = "registration_url";
    private URI registrationUrl;

    public static final String JSON_PROPERTY_PARAMETER = "parameter";
    private String parameter;

    public static final String JSON_PROPERTY_RESOURCE_ID = "resource_id";
    private String resourceId;

    /**
     * Gets or Sets resourceType
     */
    public enum ResourceTypeEnum {
        TWEET("tweet"),
        MEDIA("media");

        private String value;

        ResourceTypeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static ResourceTypeEnum fromValue(String value) {
            for (ResourceTypeEnum b : ResourceTypeEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_RESOURCE_TYPE = "resource_type";
    private ResourceTypeEnum resourceType;

    public static final String JSON_PROPERTY_VALUE = "value";
    private String value;

    /**
     * Gets or Sets section
     */
    public enum SectionEnum {
        DATA("data"),
        INCLUDES("includes");

        private String value;

        SectionEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static SectionEnum fromValue(String value) {
            for (SectionEnum b : SectionEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_SECTION = "section";
    private SectionEnum section;

    public static final String JSON_PROPERTY_FIELD = "field";
    private String field;

    /**
     * Gets or Sets period
     */
    public enum PeriodEnum {
        DAILY("Daily"),
        MONTHLY("Monthly");

        private String value;

        PeriodEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static PeriodEnum fromValue(String value) {
            for (PeriodEnum b : PeriodEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_PERIOD = "period";
    private PeriodEnum period;

    /**
     * Gets or Sets scope
     */
    public enum ScopeEnum {
        ACCOUNT("Account"),
        PRODUCT("Product");

        private String value;

        ScopeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static ScopeEnum fromValue(String value) {
            for (ScopeEnum b : ScopeEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_SCOPE = "scope";
    private ScopeEnum scope;

    /**
     * Gets or Sets connectionIssue
     */
    public enum ConnectionIssueEnum {
        TOOMANYCONNECTIONS("TooManyConnections"),
        PROVISIONINGSUBSCRIPTION("ProvisioningSubscription"),
        RULECONFIGURATIONISSUE("RuleConfigurationIssue");

        private String value;

        ConnectionIssueEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static ConnectionIssueEnum fromValue(String value) {
            for (ConnectionIssueEnum b : ConnectionIssueEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_CONNECTION_ISSUE = "connection_issue";
    private ConnectionIssueEnum connectionIssue;

    /**
     * Gets or Sets disconnectType
     */
    public enum DisconnectTypeEnum {
        OPERATIONALDISCONNECT("OperationalDisconnect"),
        UPSTREAMOPERATIONALDISCONNECT("UpstreamOperationalDisconnect"),
        FORCEDISCONNECT("ForceDisconnect"),
        UPSTREAMUNCLEANDISCONNECT("UpstreamUncleanDisconnect"),
        SLOWREADER("SlowReader"),
        INTERNALERROR("InternalError"),
        PACKAGEUPGRADED("PackageUpgraded"),
        PACKAGEDOWNGRADED("PackageDowngraded"),
        CLIENTAPPLICATIONSTATEDEGRADED("ClientApplicationStateDegraded");

        private String value;

        DisconnectTypeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static DisconnectTypeEnum fromValue(String value) {
            for (DisconnectTypeEnum b : DisconnectTypeEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_DISCONNECT_TYPE = "disconnect_type";
    private DisconnectTypeEnum disconnectType;

    public Problem(String type, String detail, String title, Integer status, String parameter, String resourceId, ResourceTypeEnum resourceType, String value, SectionEnum section, String field) {
        this.type = type;
        this.detail = detail;
        this.title = title;
        this.status = status;
        this.parameter = parameter;
        this.resourceId = resourceId;
        this.resourceType = resourceType;
        this.value = value;
        this.section = section;
        this.field = field;
    }

    public Problem type(String type) {
        this.type = type;
        return this;
    }

    /**
     * Get type
     * @return type
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getType() {
        return type;
    }

    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setType(String type) {
        this.type = type;
    }

    public Problem detail(String detail) {
        this.detail = detail;
        return this;
    }

    /**
     * Get detail
     * @return detail
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_DETAIL)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getDetail() {
        return detail;
    }

    @JsonProperty(JSON_PROPERTY_DETAIL)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setDetail(String detail) {
        this.detail = detail;
    }

    public Problem title(String title) {
        this.title = title;
        return this;
    }

    /**
     * Get title
     * @return title
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_TITLE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getTitle() {
        return title;
    }

    @JsonProperty(JSON_PROPERTY_TITLE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setTitle(String title) {
        this.title = title;
    }

    public Problem status(Integer status) {
        this.status = status;
        return this;
    }

    /**
     * Get status
     * @return status
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_STATUS)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public Integer getStatus() {
        return status;
    }

    @JsonProperty(JSON_PROPERTY_STATUS)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setStatus(Integer status) {
        this.status = status;
    }

    public Problem errors(List<InvalidRequestProblemAllOfErrors> errors) {
        this.errors = errors;
        return this;
    }

    public Problem addErrorsItem(InvalidRequestProblemAllOfErrors errorsItem) {
        if (this.errors == null) {
            this.errors = new ArrayList<>();
        }
        this.errors.add(errorsItem);
        return this;
    }

    /**
     * Get errors
     * @return errors
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_ERRORS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public List<InvalidRequestProblemAllOfErrors> getErrors() {
        return errors;
    }

    @JsonProperty(JSON_PROPERTY_ERRORS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setErrors(List<InvalidRequestProblemAllOfErrors> errors) {
        this.errors = errors;
    }

    public Problem reason(ReasonEnum reason) {
        this.reason = reason;
        return this;
    }

    /**
     * Get reason
     * @return reason
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_REASON)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public ReasonEnum getReason() {
        return reason;
    }

    @JsonProperty(JSON_PROPERTY_REASON)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setReason(ReasonEnum reason) {
        this.reason = reason;
    }

    public Problem registrationUrl(URI registrationUrl) {
        this.registrationUrl = registrationUrl;
        return this;
    }

    /**
     * Get registrationUrl
     * @return registrationUrl
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_REGISTRATION_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getRegistrationUrl() {
        return registrationUrl;
    }

    @JsonProperty(JSON_PROPERTY_REGISTRATION_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setRegistrationUrl(URI registrationUrl) {
        this.registrationUrl = registrationUrl;
    }

    public Problem parameter(String parameter) {
        this.parameter = parameter;
        return this;
    }

    /**
     * Get parameter
     * @return parameter
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_PARAMETER)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getParameter() {
        return parameter;
    }

    @JsonProperty(JSON_PROPERTY_PARAMETER)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setParameter(String parameter) {
        this.parameter = parameter;
    }

    public Problem resourceId(String resourceId) {
        this.resourceId = resourceId;
        return this;
    }

    /**
     * Get resourceId
     * @return resourceId
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_RESOURCE_ID)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getResourceId() {
        return resourceId;
    }

    @JsonProperty(JSON_PROPERTY_RESOURCE_ID)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setResourceId(String resourceId) {
        this.resourceId = resourceId;
    }

    public Problem resourceType(ResourceTypeEnum resourceType) {
        this.resourceType = resourceType;
        return this;
    }

    /**
     * Get resourceType
     * @return resourceType
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_RESOURCE_TYPE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public ResourceTypeEnum getResourceType() {
        return resourceType;
    }

    @JsonProperty(JSON_PROPERTY_RESOURCE_TYPE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setResourceType(ResourceTypeEnum resourceType) {
        this.resourceType = resourceType;
    }

    public Problem value(String value) {
        this.value = value;
        return this;
    }

    /**
     * Get value
     * @return value
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_VALUE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getValue() {
        return value;
    }

    @JsonProperty(JSON_PROPERTY_VALUE)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setValue(String value) {
        this.value = value;
    }

    public Problem section(SectionEnum section) {
        this.section = section;
        return this;
    }

    /**
     * Get section
     * @return section
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_SECTION)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public SectionEnum getSection() {
        return section;
    }

    @JsonProperty(JSON_PROPERTY_SECTION)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setSection(SectionEnum section) {
        this.section = section;
    }

    public Problem field(String field) {
        this.field = field;
        return this;
    }

    /**
     * Get field
     * @return field
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_FIELD)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public String getField() {
        return field;
    }

    @JsonProperty(JSON_PROPERTY_FIELD)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setField(String field) {
        this.field = field;
    }

    public Problem period(PeriodEnum period) {
        this.period = period;
        return this;
    }

    /**
     * Get period
     * @return period
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_PERIOD)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public PeriodEnum getPeriod() {
        return period;
    }

    @JsonProperty(JSON_PROPERTY_PERIOD)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setPeriod(PeriodEnum period) {
        this.period = period;
    }

    public Problem scope(ScopeEnum scope) {
        this.scope = scope;
        return this;
    }

    /**
     * Get scope
     * @return scope
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_SCOPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public ScopeEnum getScope() {
        return scope;
    }

    @JsonProperty(JSON_PROPERTY_SCOPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setScope(ScopeEnum scope) {
        this.scope = scope;
    }

    public Problem connectionIssue(ConnectionIssueEnum connectionIssue) {
        this.connectionIssue = connectionIssue;
        return this;
    }

    /**
     * Get connectionIssue
     * @return connectionIssue
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_CONNECTION_ISSUE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public ConnectionIssueEnum getConnectionIssue() {
        return connectionIssue;
    }

    @JsonProperty(JSON_PROPERTY_CONNECTION_ISSUE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setConnectionIssue(ConnectionIssueEnum connectionIssue) {
        this.connectionIssue = connectionIssue;
    }

    public Problem disconnectType(DisconnectTypeEnum disconnectType) {
        this.disconnectType = disconnectType;
        return this;
    }

    /**
     * Get disconnectType
     * @return disconnectType
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_DISCONNECT_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public DisconnectTypeEnum getDisconnectType() {
        return disconnectType;
    }

    @JsonProperty(JSON_PROPERTY_DISCONNECT_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setDisconnectType(DisconnectTypeEnum disconnectType) {
        this.disconnectType = disconnectType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Problem problem = (Problem) o;
        return Objects.equals(this.type, problem.type) &&
            Objects.equals(this.detail, problem.detail) &&
            Objects.equals(this.title, problem.title) &&
            Objects.equals(this.status, problem.status) &&
            Objects.equals(this.errors, problem.errors) &&
            Objects.equals(this.reason, problem.reason) &&
            Objects.equals(this.registrationUrl, problem.registrationUrl) &&
            Objects.equals(this.parameter, problem.parameter) &&
            Objects.equals(this.resourceId, problem.resourceId) &&
            Objects.equals(this.resourceType, problem.resourceType) &&
            Objects.equals(this.value, problem.value) &&
            Objects.equals(this.section, problem.section) &&
            Objects.equals(this.field, problem.field) &&
            Objects.equals(this.period, problem.period) &&
            Objects.equals(this.scope, problem.scope) &&
            Objects.equals(this.connectionIssue, problem.connectionIssue) &&
            Objects.equals(this.disconnectType, problem.disconnectType);
    }

    @Override
    public int hashCode() {
        return Objects.hash(type, detail, title, status, errors, reason, registrationUrl, parameter, resourceId, resourceType, value, section, field, period, scope, connectionIssue, disconnectType);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Problem {\n");
        sb.append("    type: ").append(toIndentedString(type)).append("\n");
        sb.append("    detail: ").append(toIndentedString(detail)).append("\n");
        sb.append("    title: ").append(toIndentedString(title)).append("\n");
        sb.append("    status: ").append(toIndentedString(status)).append("\n");
        sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
        sb.append("    reason: ").append(toIndentedString(reason)).append("\n");
        sb.append("    registrationUrl: ").append(toIndentedString(registrationUrl)).append("\n");
        sb.append("    parameter: ").append(toIndentedString(parameter)).append("\n");
        sb.append("    resourceId: ").append(toIndentedString(resourceId)).append("\n");
        sb.append("    resourceType: ").append(toIndentedString(resourceType)).append("\n");
        sb.append("    value: ").append(toIndentedString(value)).append("\n");
        sb.append("    section: ").append(toIndentedString(section)).append("\n");
        sb.append("    field: ").append(toIndentedString(field)).append("\n");
        sb.append("    period: ").append(toIndentedString(period)).append("\n");
        sb.append("    scope: ").append(toIndentedString(scope)).append("\n");
        sb.append("    connectionIssue: ").append(toIndentedString(connectionIssue)).append("\n");
        sb.append("    disconnectType: ").append(toIndentedString(disconnectType)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
