/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * Engagement metrics for the Tweet at the time of the request.
 */
@JsonPropertyOrder({
  TweetPublicMetrics.JSON_PROPERTY_LIKE_COUNT,
  TweetPublicMetrics.JSON_PROPERTY_QUOTE_COUNT,
  TweetPublicMetrics.JSON_PROPERTY_REPLY_COUNT,
  TweetPublicMetrics.JSON_PROPERTY_RETWEET_COUNT
})
@JsonTypeName("Tweet_public_metrics")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@Introspected
public class TweetPublicMetrics {
    public static final String JSON_PROPERTY_LIKE_COUNT = "like_count";
    private Integer likeCount;

    public static final String JSON_PROPERTY_QUOTE_COUNT = "quote_count";
    private Integer quoteCount;

    public static final String JSON_PROPERTY_REPLY_COUNT = "reply_count";
    private Integer replyCount;

    public static final String JSON_PROPERTY_RETWEET_COUNT = "retweet_count";
    private Integer retweetCount;

    public TweetPublicMetrics(Integer likeCount, Integer replyCount, Integer retweetCount) {
        this.likeCount = likeCount;
        this.replyCount = replyCount;
        this.retweetCount = retweetCount;
    }

    public TweetPublicMetrics likeCount(Integer likeCount) {
        this.likeCount = likeCount;
        return this;
    }

    /**
     * Number of times this Tweet has been liked.
     * @return likeCount
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_LIKE_COUNT)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public Integer getLikeCount() {
        return likeCount;
    }

    @JsonProperty(JSON_PROPERTY_LIKE_COUNT)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setLikeCount(Integer likeCount) {
        this.likeCount = likeCount;
    }

    public TweetPublicMetrics quoteCount(Integer quoteCount) {
        this.quoteCount = quoteCount;
        return this;
    }

    /**
     * Number of times this Tweet has been quoted.
     * @return quoteCount
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_QUOTE_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getQuoteCount() {
        return quoteCount;
    }

    @JsonProperty(JSON_PROPERTY_QUOTE_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setQuoteCount(Integer quoteCount) {
        this.quoteCount = quoteCount;
    }

    public TweetPublicMetrics replyCount(Integer replyCount) {
        this.replyCount = replyCount;
        return this;
    }

    /**
     * Number of times this Tweet has been replied to.
     * @return replyCount
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_REPLY_COUNT)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public Integer getReplyCount() {
        return replyCount;
    }

    @JsonProperty(JSON_PROPERTY_REPLY_COUNT)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setReplyCount(Integer replyCount) {
        this.replyCount = replyCount;
    }

    public TweetPublicMetrics retweetCount(Integer retweetCount) {
        this.retweetCount = retweetCount;
        return this;
    }

    /**
     * Number of times this Tweet has been Retweeted.
     * @return retweetCount
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_RETWEET_COUNT)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public Integer getRetweetCount() {
        return retweetCount;
    }

    @JsonProperty(JSON_PROPERTY_RETWEET_COUNT)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setRetweetCount(Integer retweetCount) {
        this.retweetCount = retweetCount;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        TweetPublicMetrics tweetPublicMetrics = (TweetPublicMetrics) o;
        return Objects.equals(this.likeCount, tweetPublicMetrics.likeCount) &&
            Objects.equals(this.quoteCount, tweetPublicMetrics.quoteCount) &&
            Objects.equals(this.replyCount, tweetPublicMetrics.replyCount) &&
            Objects.equals(this.retweetCount, tweetPublicMetrics.retweetCount);
    }

    @Override
    public int hashCode() {
        return Objects.hash(likeCount, quoteCount, replyCount, retweetCount);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class TweetPublicMetrics {\n");
        sb.append("    likeCount: ").append(toIndentedString(likeCount)).append("\n");
        sb.append("    quoteCount: ").append(toIndentedString(quoteCount)).append("\n");
        sb.append("    replyCount: ").append(toIndentedString(replyCount)).append("\n");
        sb.append("    retweetCount: ").append(toIndentedString(retweetCount)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
