/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import example.twitter.model.CommonMediaFields;
import example.twitter.model.VideoAllOf;
import example.twitter.model.VideoAllOfNonPublicMetrics;
import example.twitter.model.VideoAllOfOrganicMetrics;
import example.twitter.model.VideoAllOfPromotedMetrics;
import example.twitter.model.VideoAllOfPublicMetrics;
import java.net.URI;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * Video
 */
@JsonPropertyOrder({
  Video.JSON_PROPERTY_HEIGHT,
  Video.JSON_PROPERTY_MEDIA_KEY,
  Video.JSON_PROPERTY_WIDTH,
  Video.JSON_PROPERTY_DURATION_MS,
  Video.JSON_PROPERTY_NON_PUBLIC_METRICS,
  Video.JSON_PROPERTY_ORGANIC_METRICS,
  Video.JSON_PROPERTY_PREVIEW_IMAGE_URL,
  Video.JSON_PROPERTY_PROMOTED_METRICS,
  Video.JSON_PROPERTY_PUBLIC_METRICS,
  Video.JSON_PROPERTY_TYPE
})
@JsonTypeName("Video")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:48.925728Z[Etc/UTC]")
@Introspected
public class Video {
    public static final String JSON_PROPERTY_HEIGHT = "height";
    private Integer height;

    public static final String JSON_PROPERTY_MEDIA_KEY = "media_key";
    private String mediaKey;

    public static final String JSON_PROPERTY_WIDTH = "width";
    private Integer width;

    public static final String JSON_PROPERTY_DURATION_MS = "duration_ms";
    private Integer durationMs;

    public static final String JSON_PROPERTY_NON_PUBLIC_METRICS = "non_public_metrics";
    private VideoAllOfNonPublicMetrics nonPublicMetrics;

    public static final String JSON_PROPERTY_ORGANIC_METRICS = "organic_metrics";
    private VideoAllOfOrganicMetrics organicMetrics;

    public static final String JSON_PROPERTY_PREVIEW_IMAGE_URL = "preview_image_url";
    private URI previewImageUrl;

    public static final String JSON_PROPERTY_PROMOTED_METRICS = "promoted_metrics";
    private VideoAllOfPromotedMetrics promotedMetrics;

    public static final String JSON_PROPERTY_PUBLIC_METRICS = "public_metrics";
    private VideoAllOfPublicMetrics publicMetrics;

    /**
     * Gets or Sets type
     */
    public enum TypeEnum {
        VIDEO("video");

        private String value;

        TypeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static TypeEnum fromValue(String value) {
            for (TypeEnum b : TypeEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_TYPE = "type";
    private TypeEnum type;

    public Video() {
    }

    public Video height(Integer height) {
        this.height = height;
        return this;
    }

    /**
     * The height of the media in pixels
     * minimum: 0
     * @return height
     **/
    @Nullable
    @Min(0)
    @JsonProperty(JSON_PROPERTY_HEIGHT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getHeight() {
        return height;
    }

    @JsonProperty(JSON_PROPERTY_HEIGHT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setHeight(Integer height) {
        this.height = height;
    }

    public Video mediaKey(String mediaKey) {
        this.mediaKey = mediaKey;
        return this;
    }

    /**
     * The Media Key identifier for this attachment.
     * @return mediaKey
     **/
    @Nullable
    @Pattern(regexp="^([0-9]+)_([0-9]+)$")
    @JsonProperty(JSON_PROPERTY_MEDIA_KEY)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getMediaKey() {
        return mediaKey;
    }

    @JsonProperty(JSON_PROPERTY_MEDIA_KEY)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setMediaKey(String mediaKey) {
        this.mediaKey = mediaKey;
    }

    public Video width(Integer width) {
        this.width = width;
        return this;
    }

    /**
     * The width of the media in pixels
     * minimum: 0
     * @return width
     **/
    @Nullable
    @Min(0)
    @JsonProperty(JSON_PROPERTY_WIDTH)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getWidth() {
        return width;
    }

    @JsonProperty(JSON_PROPERTY_WIDTH)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setWidth(Integer width) {
        this.width = width;
    }

    public Video durationMs(Integer durationMs) {
        this.durationMs = durationMs;
        return this;
    }

    /**
     * Get durationMs
     * @return durationMs
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_DURATION_MS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getDurationMs() {
        return durationMs;
    }

    @JsonProperty(JSON_PROPERTY_DURATION_MS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setDurationMs(Integer durationMs) {
        this.durationMs = durationMs;
    }

    public Video nonPublicMetrics(VideoAllOfNonPublicMetrics nonPublicMetrics) {
        this.nonPublicMetrics = nonPublicMetrics;
        return this;
    }

    /**
     * Get nonPublicMetrics
     * @return nonPublicMetrics
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_NON_PUBLIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public VideoAllOfNonPublicMetrics getNonPublicMetrics() {
        return nonPublicMetrics;
    }

    @JsonProperty(JSON_PROPERTY_NON_PUBLIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setNonPublicMetrics(VideoAllOfNonPublicMetrics nonPublicMetrics) {
        this.nonPublicMetrics = nonPublicMetrics;
    }

    public Video organicMetrics(VideoAllOfOrganicMetrics organicMetrics) {
        this.organicMetrics = organicMetrics;
        return this;
    }

    /**
     * Get organicMetrics
     * @return organicMetrics
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_ORGANIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public VideoAllOfOrganicMetrics getOrganicMetrics() {
        return organicMetrics;
    }

    @JsonProperty(JSON_PROPERTY_ORGANIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setOrganicMetrics(VideoAllOfOrganicMetrics organicMetrics) {
        this.organicMetrics = organicMetrics;
    }

    public Video previewImageUrl(URI previewImageUrl) {
        this.previewImageUrl = previewImageUrl;
        return this;
    }

    /**
     * Get previewImageUrl
     * @return previewImageUrl
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_PREVIEW_IMAGE_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getPreviewImageUrl() {
        return previewImageUrl;
    }

    @JsonProperty(JSON_PROPERTY_PREVIEW_IMAGE_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setPreviewImageUrl(URI previewImageUrl) {
        this.previewImageUrl = previewImageUrl;
    }

    public Video promotedMetrics(VideoAllOfPromotedMetrics promotedMetrics) {
        this.promotedMetrics = promotedMetrics;
        return this;
    }

    /**
     * Get promotedMetrics
     * @return promotedMetrics
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_PROMOTED_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public VideoAllOfPromotedMetrics getPromotedMetrics() {
        return promotedMetrics;
    }

    @JsonProperty(JSON_PROPERTY_PROMOTED_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setPromotedMetrics(VideoAllOfPromotedMetrics promotedMetrics) {
        this.promotedMetrics = promotedMetrics;
    }

    public Video publicMetrics(VideoAllOfPublicMetrics publicMetrics) {
        this.publicMetrics = publicMetrics;
        return this;
    }

    /**
     * Get publicMetrics
     * @return publicMetrics
     **/
    @Valid
    @Nullable
    @JsonProperty(JSON_PROPERTY_PUBLIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public VideoAllOfPublicMetrics getPublicMetrics() {
        return publicMetrics;
    }

    @JsonProperty(JSON_PROPERTY_PUBLIC_METRICS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setPublicMetrics(VideoAllOfPublicMetrics publicMetrics) {
        this.publicMetrics = publicMetrics;
    }

    public Video type(TypeEnum type) {
        this.type = type;
        return this;
    }

    /**
     * Get type
     * @return type
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public TypeEnum getType() {
        return type;
    }

    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setType(TypeEnum type) {
        this.type = type;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Video video = (Video) o;
        return Objects.equals(this.height, video.height) &&
            Objects.equals(this.mediaKey, video.mediaKey) &&
            Objects.equals(this.width, video.width) &&
            Objects.equals(this.durationMs, video.durationMs) &&
            Objects.equals(this.nonPublicMetrics, video.nonPublicMetrics) &&
            Objects.equals(this.organicMetrics, video.organicMetrics) &&
            Objects.equals(this.previewImageUrl, video.previewImageUrl) &&
            Objects.equals(this.promotedMetrics, video.promotedMetrics) &&
            Objects.equals(this.publicMetrics, video.publicMetrics) &&
            Objects.equals(this.type, video.type);
    }

    @Override
    public int hashCode() {
        return Objects.hash(height, mediaKey, width, durationMs, nonPublicMetrics, organicMetrics, previewImageUrl, promotedMetrics, publicMetrics, type);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Video {\n");
        sb.append("    height: ").append(toIndentedString(height)).append("\n");
        sb.append("    mediaKey: ").append(toIndentedString(mediaKey)).append("\n");
        sb.append("    width: ").append(toIndentedString(width)).append("\n");
        sb.append("    durationMs: ").append(toIndentedString(durationMs)).append("\n");
        sb.append("    nonPublicMetrics: ").append(toIndentedString(nonPublicMetrics)).append("\n");
        sb.append("    organicMetrics: ").append(toIndentedString(organicMetrics)).append("\n");
        sb.append("    previewImageUrl: ").append(toIndentedString(previewImageUrl)).append("\n");
        sb.append("    promotedMetrics: ").append(toIndentedString(promotedMetrics)).append("\n");
        sb.append("    publicMetrics: ").append(toIndentedString(publicMetrics)).append("\n");
        sb.append("    type: ").append(toIndentedString(type)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
